<?
/*--------------------------------------------+
| PHP-Fusion 5 - Content Management System    |
|---------------------------------------------|
| Photo Gallery v3 - Alpha Release 1          |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+---------------------------------------------+
| Photo Gallery coded by CrappoMan            |
|                    (a.k.a. Simon Patterson) |
| email: crappoman@email.com                  |
+--------------------------------------------*/

if (!defined("IN_FUSION")) { header("Location:../index.php"); exit; }

////////////////////////////////////////////////////////////////////
// Photogallery v3 Settings
////////////////////////////////////////////////////////////////////
// IMG_GIF=1
// IMG_JPG=2
// IMG_PNG=4
// IMAGETYPE_GIF=1
// IMAGETYPE_JPG=2
// IMAGETYPE_PNG=3

//     1  1 = IMAGETYPE_GIF,     GIF
//     2  2 = IMAGETYPE_JPEG,    JPG
//     4  3 = IMAGETYPE_PNG,     PNG
//     8  4 = IMAGETYPE_SWF,     SWF
//    16  5 = IMAGETYPE_PSD,     PSD
//    32  6 = IMAGETYPE_BMP,     BMP
//    64  7 = IMAGETYPE_TIFF_II, TIFF(intel byte order)
//   128  8 = IMAGETYPE_TIFF_MM, TIFF(motorola byte order)
//   256  9 = IMAGETYPE_JPC,     JPC
//   512 10 = IMAGETYPE_JP2,     JP2
//  1024 11 = IMAGETYPE_JPX,     JPX
//  2048 12 = IMAGETYPE_JB2,     JB2
//  4096 13 = IMAGETYPE_SWC,     SWC
// 16384 14 = IMAGETYPE_IFF,     IFF
// 32768 15 = IMAGETYPE_WBMP,    WBMP
// 65536 16 = IMAGETYPE_XBM,     XBM


//   IMAGETYPE_TIFF_II => 'TIFF(intel byte order)',
//   IMAGETYPE_TIFF_MM => 'TIFF(motorola byte order)',
$image_types_map=array(
  IMAGETYPE_GIF     => 'GIF',
  IMAGETYPE_JPEG    => 'JPG',
  IMAGETYPE_PNG     => 'PNG',
  IMAGETYPE_SWF     => 'SWF',
  IMAGETYPE_PSD     => 'PSD',
  IMAGETYPE_BMP     => 'BMP',
  IMAGETYPE_TIFF_II => 'TIFF(int)',
  IMAGETYPE_TIFF_MM => 'TIFF(mot)',
  IMAGETYPE_JPC     => 'JPC',
  IMAGETYPE_JP2     => 'JP2',
  IMAGETYPE_JPX     => 'JPX',
  IMAGETYPE_JB2     => 'JB2',
  IMAGETYPE_SWC     => 'SWC',
  IMAGETYPE_IFF     => 'IFF',
  IMAGETYPE_WBMP    => 'WBMP',
  IMAGETYPE_XBM     => 'XBM'
);


$settings['pg_albums_per_page']=20;
$settings['pg_useralbums_per_page']=2;

$settings['pg_thumbs_per_row']=3;
$settings['pg_thumbs_per_page']=12;

$settings['pg_thumb_max_w']=120;
$settings['pg_thumb_max_h']=80;

$settings['pg_image_max_w']=1024;
$settings['pg_image_max_h']=768;
$settings['pg_image_max_b']=150000;
$settings['pg_gd_version']='gd2';

$settings['pg_allowed_comments']='1';
$settings['pg_allowed_ratings']='1';

$settings['pg_image_storage']='d';  // 'f'=file, 'd'=database

$settings['pg_allowed_image_types']='1110000000000000';

$cancreategif=(imagetypes() && IMG_GIF);
// $image_types=array(
//   IMAGETYPE_GIF  => array(IMG_GIF, 'gif', 'image/gif'),
//   IMAGETYPE_JPEG => array(IMG_JPG, 'jpg', 'image/jpeg'),
//   IMAGETYPE_PNG  => array(IMG_PNG, 'png', 'image/png')
// );
//$settings['pg_allowed_image_types']= IMG_GIF + IMG_JPG + IMG_PNG;  // Bit field: 1=GIF, 2=JPG, 4=PNG
//$settings['pg_auto_convert_gif']=0;  // convert gif's to other image type if no GIF creation support: 0=disable, 1=JPG, 2=PNG

$settings['pg_default_img_type']='png';

$settings['pg_default_jpeg_quality']=75;
$settings['pg_allow_user_galleries']=1;
$settings['pg_allow_user_passwords']=1;
$settings['pg_allow_user_ext_image']=1;
$settings['pg_ext_image_new_window']=1;

$settings['pg_ttf_font_dir']='/ANBC/_stuff/';  // folder containing TTF fonts if used.

// watermark: common settings
$settings['pg_wmark_type']='none';  // none|text|image
$settings['pg_wmark_align']='BR';  // * (tile)|T|B|L|R|C|TL|TR|BL|BR  alignment of watermark
$settings['pg_wmark_opacity']='50';  // 0-127  opacity of watermark 0=opaque, 127=transparent
$settings['pg_wmark_margin']='2';  // 0-x  watermark margin

// watermark: 'image' settings
//$settings['pg_wmark_image_file']='fusion_images/watermark5.gif';  //  image watermark to use, either path relative to root, or a full path, or a full URL.
$settings['pg_wmark_image_file']='http://localhost/fusion_images/watermark2.png';

// watermark: 'text' settings
$settings['pg_wmark_text']='localhost';  //  value of text watermark
$settings['pg_wmark_angle']='0';  //  0-x  angle of text watermark
$settings['pg_wmark_hex_color']='FFFFFF';  //  hhhhhh  color of text watermark
$settings['pg_wmark_font']='verdana.ttf';  // TTF font file to use (optional). If not provided, will use built in font specified by "$settings['pg_wmark_size']" (1-5)
$settings['pg_wmark_size']='28';  // 1-x  font size of TTF text watermark, or number of built-in font (1-5)

//$settings['pg_wmark_font']='';  // TTF font file to use (optional). If not provided, will use built in font specified by "$settings['pg_wmark_size']" (1-5)
//$settings['pg_wmark_size']='5';  // 1-x  font size of TTF text watermark, or number of built-in font (1-5)

$settings['pg_mem_limit']=0;

// temporarily set a higher memory limit to be able to manipulate large images
if(!ini_get('safe_mode') && $settings['pg_mem_limit']>0){
  @ini_set('memory_limit',($settings['pg_mem_limit']*8).'M');
}elseif(ini_get('safe_mode') && $settings['pg_mem_limit']>0){
  echo "Memory limit cannot be set because it appears your server is running in SafeMode!";
}

/////////////////////////////////////////////////

define('TICK', '<img src="'.FUSION_IMAGES.'tick.gif">');

$bool_states=array(0=>'No', 1=>'Yes');

$album_state_map=array(
 0=>array('infusion_off.gif','Inactive'),
 1=>array('infusion_on.gif', 'Active')
);


/////////////////////////////////////////////////

// returns the appropriate GD 'create' function as supported by your server
function pg_image_create_function($x_size, $y_size) {
  global $settings;
  $pg_image_create_function = ($settings['pg_gd_version'] == 'gd1' ? 'imagecreate' : 'imagecreatetruecolor');
  return $pg_image_create_function($x_size, $y_size);
}

// returns the appropriate GD 'resize' function as supported by your server
function pg_image_resize_function($dst_im, $src_im, $dstX, $dstY, $srcX, $srcY, $dstW, $dstH, $srcW, $srcH) {
  global $settings;
  $pg_image_resize_function = ($settings['pg_gd_version'] == 'gd1' ? 'imagecopyresized' : 'imagecopyresampled');
  return $pg_image_resize_function($dst_im, $src_im, $dstX, $dstY, $srcX, $srcY, $dstW, $dstH, $srcW, $srcH);
}

function pg_get_allowed_image_types() {
  global $settings, $image_types_map;
  $allowed_image_types = array();
  for($i=0; $i < strlen($settings['pg_allowed_image_types']); $i++) if(substr($settings['pg_allowed_image_types'],$i,1) == '1') $allowed_image_types[$i+1] = $image_types_map[$i+1];
  return $allowed_image_types;
}

function pg_is_allowed_image_type($img_type) {
  global $settings;
  return substr($settings['pg_allowed_image_types'], ($img_type-1), 1) == '1';
}

// check if specified album (or category if 'is_cat' is true) exists
function pg_album_exists($id, $is_cat=false) {
  global $fusion_prefix;
  return (dbresult(dbquery("SELECT COUNT(*) FROM {$fusion_prefix}photo_albums WHERE album_id='{$id}' AND album_cat".($is_cat==true?"":"!")."='0'"),0)==1);
}

// check if specified image exists
function pg_image_exists($image_id) {
  global $fusion_prefix;
  return (dbresult(dbquery("SELECT COUNT(*) FROM {$fusion_prefix}photos WHERE photo_id='{$image_id}'"),0)==1);
}

// function useralbumexists($user_id) {
//   global $fusion_prefix;
//   return (dbresult(dbquery("SELECT COUNT(*) FROM {$fusion_prefix}photos WHERE album_id='0' AND user_id='{$user_id}'"),0)>0);
// }

// check if specified user exists
function pg_user_exists($user_id) {
  global $fusion_prefix;
  return (dbresult(dbquery("SELECT COUNT(*) FROM {$fusion_prefix}users WHERE user_id='{$user_id}'"),0)==1);
}

// check if current user (guest or member) can access the specified category
function pg_can_access_cat($cat_id) {
  global $fusion_prefix;
  $sql_where_access_groups=get_user_groups_as_sql_where('album_data');
  $q_cat=dbquery("SELECT COUNT(*) FROM {$fusion_prefix}photo_albums WHERE album_cat='0' AND({$sql_where_access_groups}) AND album_id='{$cat_id}'");
  if(iSUPERADMIN) {
    return true;  // SuperAdmin can see everything!
  }elseif(dbrows($q_cat)==0) {
    return false;  // if we are here, user don't have enough priviledges or the category doesn't exist
  }else{
    return dbresult($q_cat,0);
  }
}

// check if current user (guest or member) can access the specified album
function pg_can_access_album($album_id) {
  global $fusion_prefix;
  $q_album=dbquery("SELECT album_cat FROM {$fusion_prefix}photo_albums WHERE album_id='{$album_id}'");
  if(iSUPERADMIN) {
    return true;  // SuperAdmin can see everything!
  }elseif(dbrows($q_album)==0) {
    return false;  // if we are here, album doesn't exist
  }else{
    return pg_can_access_cat(dbresult($q_album,0));
  }
}

// check if current user (guest or member) can access the specified gallery image
function pg_can_access_image($image_id) {
  global $fusion_prefix;
  $q_image=dbquery("SELECT album_id FROM {$fusion_prefix}photos WHERE photo_id='{$image_id}'");
  if(iSUPERADMIN) {
    return true;  // SuperAdmin can see everything!
  }elseif(dbrows($q_image)==0) {
    return false;  // if we are here, image doesn't exist
  }else{
    return pg_can_access_album(dbresult($q_image,0));
  }
}

function pg_get_album_password($album_id) {
  global $fusion_prefix;
  return stripinput(dbresult(dbquery("SELECT album_password FROM {$fusion_prefix}photo_albums WHERE album_id='{$album_id}'"),0));
}

// returns how many albums in a specified category
function pg_get_count_albums($cat_id) {
  global $fusion_prefix;
  return dbresult(dbquery("SELECT COUNT(*) FROM {$fusion_prefix}photo_albums WHERE album_cat='{$cat_id}'"),0);
}

// returns how many images in a specified album
function pg_get_count_images($album_id) {
  global $fusion_prefix;
  return dbresult(dbquery("SELECT COUNT(*) FROM {$fusion_prefix}photos WHERE album_id='{$album_id}'"),0);
}

// check if album is set 'active'
function pg_is_album_active($album_id) {
  global $fusion_prefix;
  $q_album=dbquery("SELECT album_active FROM {$fusion_prefix}photo_albums WHERE album_id='{$album_id}'");
//   if(iSUPERADMIN) {
//     return true;  // SuperAdmin can see everything!
//   }else
if(dbrows($q_album)==0) {
    return false;
  }else{
    return dbresult($q_album,0);
  }
}

// check if image (and parent album) is set 'active'
function pg_is_image_active($photo_id) {
  global $fusion_prefix;
  $q_image=dbquery("SELECT album_id,photo_active FROM {$fusion_prefix}photos WHERE photo_id='{$photo_id}'");
//   if(iSUPERADMIN) {
//     return true;  // SuperAdmin can see everything!
//   }else
if(dbrows($q_image)==0) {
    return false; // if we are here, image doesn't exist
  }else{
    $d_image=dbarray($q_image);
    return ($d_image['photo_active'] && pg_is_album_active($d_image['album_id']));
  }
}

// Gets the filesize of a remotely located file
//  @param    string    $url     URL to file
//  @return   integer            filesize in bytes
function pg_get_remote_file_size($url) {
  $parsedUrl=parse_url($url);
  $host=$parsedUrl['host'];
  $path=$parsedUrl['path'];
  $ourhead='';
  $fp=fsockopen($host,80,$errno,$errstr,20);
  if(!$fp){
    exit("$errstr ($errno)<br />\n");
  }else{
    $out ="HEAD $url HTTP/1.1\r\n";
    $out.="HOST: dummy\r\n";
    $out.="Connection: close\r\n\r\n";
    fputs($fp,$out);
    while(!feof($fp)){
      $ourhead=sprintf("%s%s",$ourhead,fgets($fp,128));
    }
  }
  fclose($fp);
  $split1=explode("content-length: ",strtolower($ourhead));
  if(!@$split1[1]) exit('Error: No content length');
  $split2=explode("\r\n", $split1[1]);
  $size=(int)$split2[0];  // size in bytes
  return $size;
}

function pg_repair_order_albums_all() {
  global $fusion_prefix;
  $result=dbquery("SELECT album_id FROM {$fusion_prefix}photo_albums WHERE album_cat='0' ORDER BY album_title");
  if(dbrows($result)>0) {
    $ids=array();
    while($data=dbarray($result)) $ids[]=$data['album_id'];
    foreach($ids as $id) pg_repair_order_albums($id);
  }
}

function pg_repair_order_albums($cat_id) {
  global $fusion_prefix;
  $result=dbquery("SELECT album_id FROM {$fusion_prefix}photo_albums WHERE album_cat='{$cat_id}' ORDER BY album_order,album_active DESC,album_title");
  if(dbrows($result)>0) {
    while($data=dbarray($result)) $ids[]=$data['album_id'];
    $o=1;
    foreach($ids as $id) $result=dbquery("UPDATE {$fusion_prefix}photo_albums SET album_order='".$o++."' WHERE album_id='{$id}'");
  }
}

function pg_repair_order_photos($album_id) {
  global $fusion_prefix;
  $result=dbquery("SELECT photo_id FROM {$fusion_prefix}photos WHERE album_id='{$album_id}' ORDER BY photo_order,photo_active,photo_date,photo_title");
  if(dbrows($result)>0) {
    while($data=dbarray($result)) $ids[]=$data['photo_id'];
    $o=1;
    foreach($ids as $id) $result=dbquery("UPDATE {$fusion_prefix}photos SET photo_order='".$o++."' WHERE photo_id='{$id}'");
  }
}
/////////////////////////////////////////////////
function pg_build_category_optionlist($sel_cat_id=0, $add_view_all=false) {
  global $fusion_prefix;
  $res = "";
  $result = dbquery("SELECT album_id,album_title FROM {$fusion_prefix}photo_albums WHERE album_cat='0' ORDER BY album_title");
  if(dbrows($result) > 0) {
    if($add_view_all == true) $res .= "<option value='0'>"."View All"."</option>\n";
    while($data = dbarray($result)) {
      $res .= "<option value='{$data['album_id']}'".($data['album_id']==$sel_cat_id ? ' selected' : '').">{$data['album_title']}</option>\n";
    }
  }else{
    $res = "<option value='0'>"."No Categories Defined"."</option>\n";
  }
  return $res;
}

/////////////////////////////////////////////////

// function pg_can_access_category($cat_groups) {
//   global $fusion_prefix,$userdata;
//   $groups=explode(".", $cat_groups);
// //  return (dbresult(dbquery("SELECT COUNT(*) FROM {$fusion_prefix}photo_albums WHERE album_id='{$album_id}' AND album_access<='{$userdata['user_mod']}' AND album_cat!='0'"),0)==1);
// }

/////////////////////////////////////////////////
function pg_build_album_optionlist($add_view_all=false, $sel_cat_id=0, $sel_album_id=0) {
  global $fusion_prefix;
  $res="\n";
  $sql_where_access_groups=get_user_groups_as_sql_where('tc.album_data');

//echo $sql_where_access_groups;
//exit();

  $aresult=dbquery(
    "SELECT tc.album_id AS cat_id, tc.album_title AS cat_title, ta.* ".
    "FROM {$fusion_prefix}photo_albums tc ".
    "JOIN {$fusion_prefix}photo_albums ta ON tc.album_id=ta.album_cat ".
    "WHERE ta.album_active='1' AND({$sql_where_access_groups}) AND tc.album_cat='0' ".($sel_cat_id>0?"AND tc.album_id='{$sel_cat_id}'":"").
    "ORDER BY cat_title,album_order"
  );
  if(dbrows($aresult)>0){
    if($add_view_all) $res.="<option value='0'>"."View All"."</option>\n";
    $album_cat_old=0;
    while($adata=dbarray($aresult)){
      if($adata['album_cat']<>$album_cat_old){
        if(isset($optgroup_open) && $optgroup_open) $res.="</optgroup>";
        $res.="<optgroup label='".stripslashes($adata['cat_title'])."'>\n";
        $optgroup_open=true;
      }
      $res.="<option value='{$adata['album_id']}'".($adata['album_id']==$sel_album_id?" selected":"").">{$adata['album_title']}</option>\n";
      $album_cat_old=$adata['album_cat'];
    }
    if($optgroup_open) $res.="</optgroup>";
  }else{
    $res="<option value='0'>"."No Categories Defined"."</option>\n";
  }
  return $res;
}
/////////////////////////////////////////////////
function pg_build_photo_optionlist($album_id,$sel_photo_id=0){
  global $fusion_prefix;
  $res="";
  $result=dbquery("SELECT photo_id,album_id,photo_title FROM {$fusion_prefix}photos WHERE album_id='{$album_id}' AND photo_active='1' ORDER BY photo_order");
  if(dbrows($result)>0){
    while($data=dbarray($result)){
      $res.="<option value='{$data['photo_id']}'".($data['photo_id']==$sel_photo_id?' selected':'').">{$data['photo_title']}</option>\n";
    }
  }else{
    $res="<option value='0'>"."This Photo Album is empty"."</option>\n";
  }
  return $res;
}
/////////////////////////////////////////////////
// function pg_build_usergroup_optionlist($sel_group_id) {
//   $res = "";
//   $user_groups = getusergroups();
//   while(list($key, $user_group) = each($user_groups)){
//     $res .= "<option value='{$user_group['0']}'".($sel_group_id == $user_group['0'] ? " selected" : "").">{$user_group['1']}</option>\n";
//   }
//   return $res;
// }
/////////////////////////////////////////////////

function pg_build_user_optionlist($sel_user_id, $order="user_name") {
  global $fusion_prefix;
  $res="";
  $uresult=dbquery("SELECT user_id,user_name FROM {$fusion_prefix}users ORDER BY {$order}");
  while($udata=dbarray($uresult)) $res.="<option ".($udata['user_id']==$sel_user_id?"selected":"")." value='".$udata['user_id']."'>".$udata['user_name']."</option>";
  return $res;
}

// function pg_build_user_optionlist($sel_user_id, $group_id, $order="user_name") {
//   global $fusion_prefix;
//   $res="";
//   switch($group_id) {
//    case 0:
//    case 250:
//     $sql_where="";
//    break;
//    case 251:
//     $sql_where="WHERE user_level = '{$group_id}'";
//    break;
//    default:
//     $sql_where="WHERE user_groups LIKE '%.{$group_id}%'";
//    break;
//   }
//   $uresult=dbquery("SELECT user_id,user_name FROM {$fusion_prefix}users {$sql_where} ORDER BY {$order}");
//   if(dbrows($uresult)>0){
//     while($udata=dbarray($uresult)) $res.="<option ".($udata['user_id']==$sel_user_id?"selected":"")." value='".$udata['user_id']."'>".$udata['user_name']."</option>";
//   }else{
//     $res="<option value='0'>".sprintf("No users in '%s'",getgroupname($group_id))."</option>\n";
//   }
//   return $res;
// }
/////////////////////////////////////////////////


function ImageOverlayFunction(&$gdimg_dest,&$img_watermark,$watermark_type,$alignment='*',$opacity=50,$margin=5){
  if(is_resource($gdimg_dest) && is_resource($img_watermark)){
    $watermark_source_x       =0;
    $watermark_source_y       =0;
    $img_source_width         =imagesx($gdimg_dest);
    $img_source_height        =imagesy($gdimg_dest);
    $watermark_source_width   =imagesx($img_watermark);
    $watermark_source_height  =imagesy($img_watermark);
    $watermark_opacity_percent=max(0,min(100,$opacity));
    $watermark_margin_percent =(100-max(0,min(100,$margin)))/100;
    if($img_source_width<$watermark_source_width || $img_source_height<$watermark_source_height) return true;
    switch ($alignment) {
     case '*':
      if($gdimg_tiledwatermark=pg_image_create_function($img_source_width, $img_source_height)) {
        ImageAlphaBlending($gdimg_tiledwatermark, false);
        ImageSaveAlpha($gdimg_tiledwatermark, true);
        $text_color_transparent=ImageColorAllocateAlpha($gdimg_tiledwatermark, 255, 0, 255, 127);
        ImageFill($gdimg_tiledwatermark, 0, 0, $text_color_transparent);
        for ($x=round((1 - $watermark_margin_percent) * $img_source_width); $x < ($img_source_width + $watermark_source_width); $x += round($watermark_source_width + ((1 - $watermark_margin_percent) * $img_source_width))) {
          for ($y=round((1 - $watermark_margin_percent) * $img_source_height); $y < ($img_source_height + $watermark_source_height); $y += round($watermark_source_height + ((1 - $watermark_margin_percent) * $img_source_height))) {
            ImageCopy(
              $gdimg_tiledwatermark,
              $img_watermark,
              $x,
              $y,
              0,
              0,
              min($watermark_source_width,  $img_source_width  - $x - ((1 - $watermark_margin_percent) * $img_source_width)),
              min($watermark_source_height, $img_source_height - $y - ((1 - $watermark_margin_percent) * $img_source_height))
            );
          }
        }
        $watermark_source_width =ImageSX($gdimg_tiledwatermark);
        $watermark_source_height=ImageSY($gdimg_tiledwatermark);
        $watermark_destination_x=0;
        $watermark_destination_y=0;
        ImageDestroy($img_watermark);
        $img_watermark=$gdimg_tiledwatermark;
      }
     break;
     case 'T':
      $watermark_destination_x=round((($img_source_width  / 2) - ($watermark_source_width / 2)) + $watermark_margin_percent);
      $watermark_destination_y=round((1 - $watermark_margin_percent) * $img_source_height);
     break;
     case 'B':
      $watermark_destination_x=round((($img_source_width  / 2) - ($watermark_source_width / 2)) + $watermark_margin_percent);
      $watermark_destination_y=round(($img_source_height - $watermark_source_height) * $watermark_margin_percent);
     break;
     case 'L':
      $watermark_destination_x=round((1 - $watermark_margin_percent) * $img_source_width);
      $watermark_destination_y=round((($img_source_height / 2) - ($watermark_source_height / 2)) + $watermark_margin_percent);
     break;
     case 'R':
      $watermark_destination_x=round(($img_source_width - $watermark_source_width)  * $watermark_margin_percent);
      $watermark_destination_y=round((($img_source_height / 2) - ($watermark_source_height / 2)) + $watermark_margin_percent);
     break;
     case 'C':
      $watermark_destination_x=round((($img_source_width  / 2) - ($watermark_source_width / 2)) + $watermark_margin_percent);
      $watermark_destination_y=round((($img_source_height / 2) - ($watermark_source_height / 2)) + $watermark_margin_percent);
     break;
     case 'TL':
      $watermark_destination_x=round((1 - $watermark_margin_percent) * $img_source_width);
      $watermark_destination_y=round((1 - $watermark_margin_percent) * $img_source_height);
     break;
     case 'TR':
      $watermark_destination_x=round(($img_source_width - $watermark_source_width)  * $watermark_margin_percent);
      $watermark_destination_y=round((1 - $watermark_margin_percent) * $img_source_height);
     break;
     case 'BL':
      $watermark_destination_x=round((1 - $watermark_margin_percent) * $img_source_width);
      $watermark_destination_y=round(($img_source_height - $watermark_source_height) * $watermark_margin_percent);
     break;
     case 'BR':
     default:
      $watermark_destination_x=round(($img_source_width  - $watermark_source_width)  * $watermark_margin_percent);
      $watermark_destination_y=round(($img_source_height - $watermark_source_height) * $watermark_margin_percent);
     break;
    }
    switch($watermark_type){
     case 1:
     case 2:
      imagecolortransparent($img_watermark,imagecolorat($img_watermark,0,0));
      imagecopymerge($gdimg_dest,$img_watermark,$watermark_destination_x,$watermark_destination_y,$watermark_source_x,$watermark_source_y,$watermark_source_width,$watermark_source_height,$watermark_opacity_percent);
     break;
     case 3:
//ImageAlphaBlending($gdimg_dest, true);
      imagecopy($gdimg_dest,$img_watermark,$watermark_destination_x,$watermark_destination_y,$watermark_source_x,$watermark_source_y,$watermark_source_width,$watermark_source_height);
//      imagecopymerge($gdimg_dest,$img_watermark,$watermark_destination_x,$watermark_destination_y,$watermark_source_x,$watermark_source_y,$watermark_source_width,$watermark_source_height,$watermark_opacity_percent);
     break;
    }
    return true;
  }
  return false;
}

///////////////////////////////////
function constrainImage($img_w,$img_h,$max_w,$max_h,$sized){
  if($max_w>0 && $max_h>0){
    if($sized>0){
      $out_w=$max_w;
      $out_h=$max_h;
    }elseif(($img_w/$img_h)>($max_w/$max_h)){
      $out_w=$max_w;
      $out_h=$img_h*($max_w/$img_w);
    }else{
      $out_w=$img_w*($max_h/$img_h);
      $out_h=$max_h;
    }
  }elseif($max_w>0){
    $out_w=$max_w;
    $out_h=$img_h*($max_w/$img_w);
  }elseif($max_h>0){
    $out_w=$img_w*($max_h/$img_h);
    $out_h=$max_h;
  }else{
    $out_w=$img_w;
    $out_h=$img_h;
  }
  return array($out_w,$out_h);
}
///////////////////////////////////


function pg_build_optionlist_from_array($array,$select_one=-1) {
  $res = "";
  foreach($array as $array_key=>$array_data) {
    $res .= "<option ".($array_key==$select_one?"selected ":"")."value='{$array_key}'>{$array_data}</option>\n";
  }
  return $res;
}
/////////////////////////////////////////////////

function get_optionlist_as_string($select_name,$glue) {
  $res=array_values(stripinput($_POST["{$select_name}"]));
  sort($res,SORT_NUMERIC);
  $res=implode($glue,$res);
  return $res;
}
/////////////////////////////////////////////////

function pg_delete_image_file($img_id,$is_album=false) {
  global $fusion_prefix,$image_types_map;
  $db_names=array(
   array('photo_info','photos','photo_id'),
   array('album_info','photo_albums','album_id')
  );
  $data='';
  $img_info='';
  $result=dbquery("SELECT {$db_names[$is_album][0]} AS img_info FROM {$fusion_prefix}{$db_names[$is_album][1]} WHERE {$db_names[$is_album][2]}='{$img_id}'");
  if(dbrows($result)==1) {
    $data=dbarray($result);
    $img_info=$data['img_info'];
    preg_match('/^([0-9]+)\|([0-9]+)\|([0-9]+)$/',$img_info,$image_info_matches);
    if(count($image_info_matches)==4){
      $file=FUSION_PHOTOS.($is_album?'a':'')."{$img_id}.{$image_types_map[$image_info_matches[1]]}";
      if(file_exists($file)) unlink($file);
    }
  }
}


/////////////////////////////////////////////////

//function get_user_groups_as_sql_where($user_id,$field_name) {
function get_user_groups_as_sql_where($field_name) {
  global $fusion_prefix;
  $res = "";
  $grps = array();
  $a_grps = explode('.',iUSER_GROUPS);
  foreach($a_grps as $k=>$grp) {
    if(!empty($grp)) { $grps[] = " {$field_name} LIKE '%.{$grp}.%' "; }
  }
  $grps[] = " {$field_name} LIKE '%.".iUSER.".%' ";
  if(iSUPERADMIN) $grps[] = " 1=1 ";
  $res = implode('OR',$grps);
//echo $res;
  return $res;
}
/////////////////////////////////////////////////

function pg_show_db_info() {
  global $fusion_prefix,$settings;
  $pg_info_1 = dbresult(dbquery("SELECT COUNT(*) FROM {$fusion_prefix}photo_albums WHERE album_cat='0'"),0);
  $pg_info_2 = dbresult(dbquery("SELECT COUNT(*) FROM {$fusion_prefix}photo_albums WHERE album_cat!='0'"),0);
  $pg_info_3 = dbresult(dbquery("SELECT COUNT(*) FROM {$fusion_prefix}photos WHERE album_id='0'"),0);
  $pg_info_4 = dbresult(dbquery("SELECT COUNT(*) FROM {$fusion_prefix}photos WHERE album_id!='0'"),0);
  $pg_info_5 = ($settings['pg_image_storage']=='f'?'files':'database');
  $pg_info_6 = dbresult(dbquery("SELECT SUM(photo_views) FROM {$fusion_prefix}photos"),0);
  opentable('Photo Gallery Statistics');
  echo sprintf("<b>%d</b> Album Categories; <b>%d</b> Albums; <b>%d</b> Member Albums; <b>%d</b> Images stored in <b>%s</b>; <b>%d</b> Image views", $pg_info_1,$pg_info_2,$pg_info_3,$pg_info_4,$pg_info_5,$pg_info_6);
  closetable();
}

////////////////////////////////////////////////////////////////////
// Extra Functions
////////////////////////////////////////////////////////////////////

function dbinsertid() {
  if (!$query = mysql_insert_id()) echo mysql_error();
  return $query;
}

function prepPageNav($page,$rows,$itemsperpage){
  $page_cnt=max(1,ceil($rows/$itemsperpage));
  $page=strtolower($page);
  if($page=="all")       $page=0;
  elseif($page=="first") $page=1;
  elseif($page=="last")  $page=$page_cnt;
  if($page==0){
//    $page=0;
    $limit_start=0;
    $limit_count=$rows;
  }else{
//    $page=$page+0;
    if(isNum($page)){
      $page=min(max($page,1),$page_cnt);
      $limit_start=($page-1)*$itemsperpage;
      $limit_count=$itemsperpage;
    }else{
      $page=1;
      $limit_start=0;
      $limit_count=$itemsperpage;
    }
  }
  return array($page,$page_cnt,$limit_start,$limit_count);
}

define("LAN_54", "All");
define("LAN_55", "All Pages");
define("LAN_56", "1");

function makePageNavAll($page_cur,$page_cnt,$page_range=3,$link="",$paramname="page"){
  $res="";
  if($link=="")$link=$_SERVER['PHP_SELF']."?";
  if($page_cnt>1){
    $res="<table border='0' cellpadding='1' cellspacing='1' class='tbl-border'>\n<tr>\n";
    if($page_cur==0){
      $res.="<td class='tbl2'><span class='small'>".LAN_55."</span></td>\n";
      $res.="<td class='tbl1'><a class='small' href='{$link}{$paramname}=1'>".LAN_56."</a></td>\n";
    }else{
      $res.="<td class='tbl2'><span class='small'>".LAN_52."$page_cur".LAN_53."{$page_cnt}</span></td>\n";
      $res.="<td class='tbl1'><a class='small' href='{$link}{$paramname}=all'>".LAN_54."</a></td>\n";
      if($page_cur>1){
        if($page_cur>($page_range+1) && $page_range!=0){
          $res.="<td class='tbl2'><a class='small' href='{$link}{$paramname}=1'>&lt;&lt;</a></td>\n";
        }
        $res.="<td class='tbl2'><a class='small' href='{$link}{$paramname}=".($page_cur-1)."'>&lt;</a></td>\n";
      }
      if($page_range==0){
        $idx_fst=1;
        $idx_lst=$page_cnt;
      }else{
        $idx_fst=max($page_cur-$page_range,1);
        $idx_lst=min($page_cur+$page_range,$page_cnt);
      }
      for($i=$idx_fst;$i<=$idx_lst;$i++){
        if($i==$page_cur){
          $res.="<td class='tbl1'><span class='small'><b>$i</b></span></td>\n";
        }else{
          $res.="<td class='tbl1'><a class='small' href='{$link}{$paramname}={$i}'>$i</a></td>\n";
        }
      }
      if($page_cur<$page_cnt){
        $res.="<td class='tbl2'><a class='small' href='{$link}{$paramname}=".($page_cur+1)."'>&gt;</a></td>\n";
        if($page_cur<($page_cnt-$page_range) && $page_range!=0){
          $res.="<td class='tbl2'><a class='small' href='{$link}{$paramname}={$page_cnt}'>&gt;&gt;</a></td>\n";
        }
      }
    }
    $res.="</tr>\n</table>\n";
  }
  return $res;
}

?>