<?
/*--------------------------------------------+
| PHP-Fusion 5 - Content Management System    |
|---------------------------------------------|
| Photo Gallery v3 - Alpha Release 1          |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+---------------------------------------------+
| Photo Gallery coded by CrappoMan            |
|                    (a.k.a. Simon Patterson) |
| email: crappoman@email.com                  |
+--------------------------------------------*/
@include "fusion_config.php";
include "fusion_core.php";
include "subheader.php";
//include FUSION_LANGUAGES.FUSION_LAN."photogallery.php";
//include FUSION_LANGUAGES.FUSION_LAN."comments.php";
include "side_left.php";
include FUSION_INCLUDES."pg_core.php";


function make_photo_navbar($photo_id){
  global $fusion_prefix, $PHP_SELF;
  $res="";
  $q_photo=dbquery("SELECT album_id,photo_order FROM {$fusion_prefix}photos WHERE photo_id='{$photo_id}' LIMIT 1");
  if(dbrows($q_photo)>0){
    $d_photo=dbarray($q_photo);
    $album_id=$d_photo['album_id'];
    $photo_ord=($d_photo['photo_order']);
    $q_prev=dbquery("SELECT * FROM {$fusion_prefix}photos ".
                    "WHERE album_id='{$album_id}' AND photo_active='1' AND photo_order<'{$photo_ord}' ".
                    "ORDER BY photo_order DESC LIMIT 1"
    );
    $q_next=dbquery("SELECT * FROM {$fusion_prefix}photos ".
                    "WHERE album_id='{$album_id}' AND photo_active='1' AND photo_order>'{$photo_ord}' ".
                    "ORDER BY photo_order LIMIT 1"
    );
    $prev=0;
    $next=0;
    if(dbrows($q_prev)!=0) { $prev=dbresult($q_prev,0); }
    if(dbrows($q_next)!=0) { $next=dbresult($q_next,0); }
    $res.="<table border='0' align='center' cellpadding='0' cellspacing='1' class='tbl-border'>\n";
    $res.=" <tr>\n";
    if($prev!=0) $res.="  <td class='tbl1'><span class='small'><a href='{$PHP_SELF}?photo_id={$prev}' title='"."Click to view the previous image in this Album"."'>".' Previous Image'."</a></span></td>\n";
    $res.="  <td class='tbl2'><span class='small'><a href='{$PHP_SELF}?album_id={$album_id}' title='"."Click to return to the Photo Album"."'>"."Return to Album"."</a></span></td>\n";
    if($next!=0) $res.="  <td class='tbl1'><span class='small'><a href='{$PHP_SELF}?photo_id={$next}' title='"."Click to view the next image in this Album"."'>".'Next Image '."</a></span></td>\n";
    $res.=" </tr>\n";
    $res.="</table>\n";
  }
  return $res;
}

function make_album_navbar($album_id){
  global $fusion_prefix, $PHP_SELF;
  $res="";
  $q_album=dbquery("SELECT album_cat,album_order FROM {$fusion_prefix}photo_albums WHERE album_id='{$album_id}' LIMIT 1");
  if(dbrows($q_album)>0){
    $d_album=dbarray($q_album);
    $album_cat=$d_album['album_cat'];
    $album_ord=($d_album['album_order']);
    $q_prev=dbquery("SELECT * FROM {$fusion_prefix}photo_albums ".
                    "WHERE album_cat='{$album_cat}' AND album_active='1' AND album_order<'{$album_ord}' ".
                    "ORDER BY album_order DESC LIMIT 1"
    );
    $q_next=dbquery("SELECT * FROM {$fusion_prefix}photo_albums ".
                    "WHERE album_cat='{$album_cat}' AND album_active='1' AND album_order>'{$album_ord}' ".
                    "ORDER BY album_order LIMIT 1"
    );
    $prev=0;
    $next=0;
    if(dbrows($q_prev)!=0) { $prev=dbresult($q_prev,0); }
    if(dbrows($q_next)!=0) { $next=dbresult($q_next,0); }
    $res.="<table border='0' align='center' cellpadding='0' cellspacing='1' class='tbl-border'>\n";
    $res.=" <tr>\n";
    if($prev!=0) $res.="  <td class='tbl1'><span class='small'><a href='{$PHP_SELF}?album_id={$prev}' title='"."Click to view the previous Album in this Category"."'>"." Previous Album"."</a></span></td>\n";
    $res.="  <td class='tbl2'><span class='small'><a href='{$PHP_SELF}' title='"."Click to return to the Photo Album list"."'>"."Return to Photo Gallery"."</a></span></td>\n";
    if($next!=0) $res.="  <td class='tbl1'><span class='small'><a href='{$PHP_SELF}?album_id={$next}' title='"."Click to view the next Album in this Category"."'>"."Next Album "."</a></span></td>\n";
    $res.=" </tr>\n";
    $res.="</table>\n";
  }
  return $res;
}

function make_user_navbar(){
  global $PHP_SELF;
  tablebreak();
  echo "<table border='0' align='center' cellpadding='0' cellspacing='1' class='tbl-border'>\n";
  echo " <tr>\n";
  echo "  <td class='tbl2'><span class='small'><a href='{$PHP_SELF}' title='"."Click to return to the Photo Album list"."'>"."Return to Photo Gallery"."</a></span></td>\n";
  echo " </tr>\n";
  echo "</table>\n";
  tablebreak();
}

////////////////////////////////////////

$params=array('cat_id','album_id','photo_id','user_id');  // URL params to validate

foreach($params as $_p){  // validate params
  if(isset($$_p)) {
    $$_p=stripinput($$_p);
    if(!isNum($$_p)) $error=sprintf('Invalid %s specified.', strtoupper($_p));
  }else{
    $$_p=0;
  }
}

if($cat_id>0){  // validate 'cat_id'
  if(!pg_album_exists($cat_id,true)){
    $error="Invalid CAT_ID specified.";
  }elseif(!pg_can_access_cat($cat_id)){
    $error="You do not have sufficient privileges to view this Category.";
  }
}

if($album_id>0){  // validate 'album_id'
  $album_pw=pg_get_album_password($album_id);
  if(!pg_album_exists($album_id,false)){
    $error="Invalid ALBUM_ID specified.";
  }elseif(!pg_can_access_album($album_id)){
    $error="You do not have sufficient privileges to view this Photo Album.";
  }elseif(!pg_is_album_active($album_id)){
    $error="Access to this Album has been temporarily disabled. Please try again later.";
  }
}else{
  $album_pw='';
}

if($photo_id>0){  // validate 'photo_id'
  if(!pg_image_exists($photo_id,true)){
    $error="Invalid PHOTO_ID specified.";
  }elseif(!pg_can_access_image($photo_id)){
    $error="You do not have sufficient privileges to view this Image.";
  }elseif(!pg_is_image_active($photo_id)){
    $error="Access to this Image has been temporarily disabled. Please try again later.";
  }
}

if(isset($pass)){
  $pass=stripinput($pass);
}else{
  $pass='';
}

if($user_id>0){
  if(!pg_user_exists($user_id)){
    $error="Invalid USER_ID specified.";
  }
}

if(!isset($page)) $page=1;

////////////////////////////////////////////

if(isset($error)){
  opentable("Error");
  echo "<center><br />{$error}<br /><br /><a href='{$PHP_SELF}'>Return to Photo Gallery</a><br /><br /></center>\n";
  closetable();
}elseif(isset($_POST['btn_cancel'])){
  header('Location: '.$PHP_SELF);  exit();
}elseif($photo_id>0){
  include FUSION_INCLUDES."comments_include.php";
  include FUSION_INCLUDES."ratings_include.php";
  $result=dbquery("UPDATE {$fusion_prefix}photos SET photo_views=(photo_views+1) WHERE photo_id='{$photo_id}'");
  $q_photo=dbquery(
    "SELECT tp.photo_id, tp.album_id, tp.photo_title, tp.photo_desc, tp.photo_order, tp.photo_date, tp.user_id, tp.photo_views, tp.photo_info, user_name ".
    "FROM {$fusion_prefix}photos AS tp ".
    "INNER JOIN {$fusion_prefix}users USING(user_id) ".
    "WHERE photo_id='{$photo_id}' ".
    "LIMIT 1"
  );
  $d_photo=dbarray($q_photo);
  $album_id=$d_photo['album_id'];
  $photo_title=stripslashes($d_photo['photo_title']);
  $photo_desc=nl2br(stripslashes($d_photo['photo_desc']));
  opentable(sprintf("Image %d: %s",$photo_id,$photo_title));
  echo "<form name='frm_gallery' method='post' action='{$PHP_SELF}'>\n";
  echo "<table border='0' cellpadding='0' cellspacing='0' width='100%'>\n";
  echo " <tr>\n";
  echo "  <td class='tbl1' align='center'>\n".make_photo_navbar($photo_id)."\n  </td>\n";
  echo "  <td class='tbl1' nowrap width='1%' align='right'>"."Image".": <select name='photo_id' class='textbox' onChange='javascript:document.frm_gallery.submit();'>".pg_build_photo_optionlist($album_id,$photo_id)."</select></td>\n";
  echo " </tr>\n";
  echo "</table>\n";
  echo "</form>\n";
  preg_match('/^([0-9]+)\|([0-9]+)\|([0-9]+)$/',$d_photo['photo_info'],$image_info_matches);
  if(count($image_info_matches)==4){
    $img_t=$image_info_matches[1];
    $img_w=$image_info_matches[2];
    $img_h=$image_info_matches[3];
    if($img_w>$settings['pg_image_max_w'] || $img_h>$settings['pg_image_max_h']) {
      list($img_w,$img_h)=constrainImage($img_w,$img_h,$settings['pg_image_max_w'],$settings['pg_image_max_h'],0);
    }
  }else{
    $img_t=0;
    $img_w=$settings['pg_thumb_max_w'];
    $img_h=$settings['pg_thumb_max_h'];
  }
  echo "<div align='center' style='margin:5px;'>\n";
  if($img_t>0) echo "<a class='gallery-photo' target='_blank' href='".FUSION_BASE."getpgimage.php?t=photo&id={$photo_id}'>\n";
  echo " <img src='".FUSION_BASE."getpgimage.php?t=photo&id={$photo_id}&w={$img_w}&h={$img_h}' title='{$photo_title}' alt='{$photo_title}' border='1'>\n";
  if($img_t>0) echo "</a>\n";
  echo "</div>\n";
  if($img_t>0){
    echo "<div align='center' style='margin:5px;'>\n";
    echo " <span class='small alt'>"."Click image to open full size in a new window"."</span>\n";
//    echo " <br /><span class='small alt'>".sprintf("(%dx%d pixels)",$img_w,$img_h)."</span><br />\n";
    echo "</div>\n";
  }
  if(!empty($photo_desc)) echo "<div class='quote' style='margin:5px;'>\n{$photo_desc}</div>\n";
  echo "<div align='center' style='margin:5px;'>\n<span class='small alt'>".sprintf("This Image was added on <b>%s</b> by <b><a href='".FUSION_BASE."profile.php?lookup=%s' title='"."Click to view this Members profile"."'>%s</a></b> and has been viewed <b>%d</b> times.", showdate('shortdate',$d_photo['photo_date']),$d_photo['user_id'],$d_photo['user_name'],$d_photo['photo_views'])."</span><br />\n</div>\n";
  closetable();
  if($settings['pg_allowed_comments']=="1"){
    showcomments("P","photos","photo_id",$photo_id,"{$PHP_SELF}?photo_id={$photo_id}");
  }
  if($settings['pg_allowed_ratings']=="1"){
    showratings("P",$photo_id,"{$PHP_SELF}?photo_id={$photo_id}");
  }
}elseif($album_id>0){
  $sql_where_access_groups=get_user_groups_as_sql_where('tc.album_data');
  $q_album=dbquery(
    "SELECT tc.album_title as cat_title, ta.album_id, ta.album_title, ta.album_desc ".
    "FROM {$fusion_prefix}photo_albums tc ".
    "LEFT JOIN {$fusion_prefix}photo_albums ta ON tc.album_id=ta.album_cat ".
    "WHERE ta.album_id='{$album_id}' ".
    "GROUP BY album_id ".
    "LIMIT 1"
  );
  $d_album=dbarray($q_album);
  $cat_title=stripslashes($d_album['cat_title']);
  $album_title=stripslashes($d_album['album_title']);
  $album_desc=nl2br(stripslashes($d_album['album_desc']));
  $d_albuminfo=dbarray(dbquery(
    "SELECT COUNT(tp.photo_id) AS photo_count, MAX(tp.photo_date) AS max_date, tu.user_id, tu.user_name ".
    "FROM {$fusion_prefix}photos tp ".
    "LEFT JOIN {$fusion_prefix}users tu USING(user_id) ".
    "WHERE tp.album_id='{$d_album['album_id']}' AND tp.photo_active='1' ".
    "GROUP BY tp.album_id "
  ));
  $photo_count=$d_albuminfo['photo_count'];
  list($page,$page_cnt,$limit_start,$limit_count)=prepPageNav($page,$photo_count,$settings['pg_thumbs_per_page']);
  $str_photo_count=($photo_count==0?"Empty Album":"No of images: "."<b>{$photo_count}</b><br />".sprintf("Latest update on %s by <b><a href='".FUSION_BASE."profile.php?lookup=%d' title='"."Click to view this Members profile"."'>%s</a></b>",showdate('shortdate',$d_albuminfo['max_date']),$d_albuminfo['user_id'],$d_albuminfo['user_name']));
  opentable("Photo Gallery");
  echo "<form name='frm_gallery' method='post' action='{$PHP_SELF}'>\n";
  echo "<table border='0' cellpadding='0' cellspacing='0' width='100%'>\n";
  echo " <tr>\n";
  echo "  <td class='tbl1' align='center'>\n".make_album_navbar($album_id)."\n  </td>\n";
  echo "  <td class='tbl1' nowrap width='1%' align='right'>"."Album".": <select name='album_id' class='textbox' onChange='javascript:document.frm_gallery.submit();'>".pg_build_album_optionlist(false,0,$album_id)."</select></td>\n";
  echo " </tr>\n";
  echo "</table>\n";
  echo "</form>\n";
  echo "<table border='0' cellpadding='0' cellspacing='1' width='100%' class='tbl-border'>\n";
  echo " <tr>\n";
  echo "  <td class='gallery-cat' nowrap>{$cat_title}</td>\n";
  echo " </tr>\n";
  echo " <tr>\n";
  echo "  <td>\n";
  echo "   <table border='0' cellpadding='0' cellspacing='0' width='100%'>\n";
  echo "    <tr>\n";
  echo "     <td class='tbl2' rowspan='2' width='".($settings['pg_thumb_max_w']+8)."' align='center'><img class='gallery-active' src='".FUSION_BASE."getpgimage.php?t=album&id={$album_id}&w=".$settings['pg_thumb_max_w']."&h=".$settings['pg_thumb_max_h']."' title='{$album_title}' alt='{$album_title}'></td>\n";
  echo "     <td class='tbl1' valign='top'><b>{$album_title}</b><br /><span class='small'>{$album_desc}</span></td>\n";
  echo "    </tr>\n";
  echo "    <tr>\n";
  echo "     <td class='tbl1' valign='bottom'><span class='small alt'>{$str_photo_count}</span></td>\n";
  echo "    </tr>\n";
  echo "   </table>\n";
  echo "  </td>\n";
  echo " </tr>\n";
  echo " <tr>\n";
  echo "  <td class='gallery-cat' nowrap>"."Album Contents"."</td>\n";
  echo " </tr>\n";
  echo " <tr>\n";
  echo "  <td class='tbl1'>";
  if($album_pw!='' && $album_pw!=$pass){
    echo "<form name='frm_album_pw' method='post' action='{$PHP_SELF}?album_id={$album_id}'>\n";
    echo "<center><br /><b>"."Enter Password to view Photo Album contents"."</b><br /><br />\n";
    if($pass!='') echo "<span class='required'>"."Error: Invalid Password"."</span><br /><br />\n";
    echo "Enter Password".": <input type='text' name='pass' value='{$pass}' class='textbox' style='width:150px;'><br /><br />\n";
    echo "<input type='submit' name='btn_pw_enter' value='"."Enter"."' class='button'> <input type='submit' name='btn_cancel' value='"."Cancel"."' class='button'><br /><br />\n";
    echo "</center>\n";
    echo "</form>\n";
  }else{
    if($photo_count>0){
      echo "<table width='100%' cellpadding='0' cellspacing='0'>\n";
      echo " <tr>\n";
      $q_photo=dbquery(
        "SELECT tp.*, COUNT(comment_item_id) AS comment_count,SUM(tr.rating_vote) AS sum_rating, COUNT(tr.rating_item_id) AS count_votes  ".
        "FROM {$fusion_prefix}photos AS tp ".
        "LEFT JOIN {$fusion_prefix}comments ON photo_id=comment_item_id AND comment_type='P' ".
        "LEFT JOIN {$fusion_prefix}ratings tr ON tr.rating_item_id=tp.photo_id AND tr.rating_type='P' ".
        "WHERE album_id='{$album_id}' AND tp.photo_active='1' ".
        "GROUP BY photo_id ".
        "ORDER BY photo_order ".
        "LIMIT {$limit_start},{$limit_count}"
      );
      $img_cnt=0;
      while($d_photo=dbarray($q_photo)){
        $photo_title=stripslashes($d_photo['photo_title']);
        $str_views="Views: <b>%s</b>";
        if($d_photo['photo_views']>0){
          $str_views=sprintf($str_views,$d_photo['photo_views']);
        }else{
          $str_views=sprintf($str_views,"None");
        }
        if($d_photo['comment_count']>0){
          $str_comments="<b>{$d_photo['comment_count']}</b> ";
          if($d_photo['comment_count']==1){
            $str_comments.="Comment";
          }else{
            $str_comments.="Comments";
          }
        }else{
          $str_comments="No Comments";
        }
        if($d_photo['count_votes']>0){
          $str_rating=str_repeat("<img src='".FUSION_IMAGES."/star.gif' alt='Rating Star'>",ceil($d_photo['sum_rating']/$d_photo['count_votes']));
        }else{
          $str_rating="";
        }
        $width=round(100/$settings['pg_thumbs_per_row']);
        echo "  <td class='gallery' align='center' valign='top' width='{$width}%'>";
        echo "<a href='{$PHP_SELF}?photo_id={$d_photo['photo_id']}' class='gallery-album'><img src='".FUSION_BASE."getpgimage.php?t=photo&id={$d_photo['photo_id']}&w={$settings['pg_thumb_max_w']}&h={$settings['pg_thumb_max_h']}' title='"."Click to view this Photo"."' alt='{$photo_title}'></a><br />{$photo_title}<br />";
        echo "<span class='small2'>{$str_views}</span><br />";
        echo "<span class='small2'>{$str_comments}</span><br />";
        echo "<span class='small2'>{$str_rating}</span>";
        if(++$img_cnt%$settings['pg_thumbs_per_row']==0) echo " </tr>\n <tr>\n";
      }
      echo " </tr>\n";
      echo "</table>\n";
    }else{
      echo "<center><br />"."No images have been added to this album."."<br /><br /></center>\n";
    }
  }
  echo "  </td>\n";
  echo " </tr>\n";
  echo "</table>\n";
  if($photo_count>$settings['pg_thumbs_per_page']){
    $link="?album_id={$album_id}&";
    if($album_pw!='') $link.="pass={$album_pw}&";
    echo "<div style='margin:5px;' align='center'>".makePageNavAll($page,$page_cnt,null,$PHP_SELF.$link)."\n</div>\n";
  }
  closetable();
}else{
  // display main album list
  opentable("Photo Gallery");
  $sql_where_access_groups=get_user_groups_as_sql_where('tc.album_data');
  $cnt_albums_total=dbresult(dbquery(  // calculate total number of albums for page nav
    "SELECT COUNT(*) ".
    "FROM {$fusion_prefix}photo_albums tc ".
    "LEFT JOIN {$fusion_prefix}photo_albums ta ON tc.album_id=ta.album_cat ".
    "WHERE tc.album_cat='0' AND({$sql_where_access_groups}) AND ta.album_active='1' ".($cat_id>0?"AND tc.album_id='{$cat_id}' ":"")
  ),0);
  list($page,$page_cnt,$limit_start,$limit_count)=prepPageNav($page,$cnt_albums_total,$settings['pg_albums_per_page']);
  $q_albumlist=dbquery(  // get list of categories and albums to display, taking account of page nav values
    "SELECT tc.album_title AS cat_title, ta.* ".
    "FROM {$fusion_prefix}photo_albums tc ".
    "LEFT JOIN {$fusion_prefix}photo_albums ta ON tc.album_id=ta.album_cat ".
    "WHERE tc.album_cat='0' AND ta.album_active='1' AND({$sql_where_access_groups}) ".($cat_id>0?"AND tc.album_id='{$cat_id}' ":"").
    "GROUP BY ta.album_id ".
    "ORDER BY tc.album_title, ta.album_order ".
    "LIMIT {$limit_start},{$limit_count}"
  );
  $cnt_albumlist_page=dbrows($q_albumlist);
  echo "<form name='frm_gallery' method='post' action='{$PHP_SELF}'>\n";
  echo "<input type='hidden' name='page' value='{$page}'>\n";
  echo "<table border='0' cellpadding='0' cellspacing='0' width='100%'>\n";
  echo " <tr>\n";
  echo "  <td class='tbl1' width='*'>"."Welcome to the {$settings['sitename']} photogallery."."</td>\n";
  if($cnt_albums_total>0 || $cat_id>0){
    echo "  <td class='tbl1' nowrap width='1%' align='right'>"."Category".": <select name='cat_id' class='textbox' onChange='javascript:document.frm_gallery.submit();'>".pg_build_category_optionlist($cat_id,true)."</select></td>\n";
  }
  echo " </tr>\n";
  echo "</table>\n";
  echo "</form>\n";
  if($cnt_albumlist_page>0){
    echo "<table border='0' cellpadding='0' cellspacing='1' width='100%' class='tbl-border'>\n";
    $album_cat_old=0;
    while($d_albumlist=dbarray($q_albumlist)){
      $d_albuminfo=dbarray(dbquery(
        "SELECT COUNT(tp.photo_id) AS photo_count, MAX(tp.photo_date) AS max_date, tu.user_id, tu.user_name ".
        "FROM {$fusion_prefix}photos tp ".
        "LEFT JOIN {$fusion_prefix}users tu USING(user_id) ".
        "WHERE tp.album_id='{$d_albumlist['album_id']}' AND tp.photo_active='1' ".
        "GROUP BY tp.album_id "
      ));
      $str_photo_updated=($d_albuminfo['max_date']!=NULL && (time()-86400)<$d_albuminfo['max_date']?"  <span class='small required'><b>"."[Updated]"."</b></span>":"");
      $str_photo_count=($d_albuminfo['photo_count']==0?"Empty Album":"No of images: "."<b>".$d_albuminfo['photo_count']."</b><br />".sprintf("Latest update on %s by <b><a href='".FUSION_BASE."profile.php?lookup=%d' title='"."Click to view this Members profile"."'>%s</a></b>",showdate('shortdate',$d_albuminfo['max_date']),$d_albuminfo['user_id'],$d_albuminfo['user_name']));
      $str_album_pw=(stripslashes($d_albumlist['album_password'])!=''?" <img align='top' src='".FUSION_IMAGES."album_pw.gif' border='0' title='"."This Album is password protected!"."'>":"");
      $cat_title=stripslashes($d_albumlist['cat_title']);
      $album_title=stripslashes($d_albumlist['album_title']);
      $album_desc=nl2br(stripslashes($d_albumlist['album_desc']));
      if($d_albumlist['album_cat']<>$album_cat_old){
        echo " <tr>\n";
        echo "  <td class='gallery-cat' nowrap>{$cat_title}</td>\n";
        echo " </tr>\n";
      }
      echo " <tr>\n";
      echo "  <td>\n";
      echo "   <table border='0' cellpadding='0' cellspacing='0' width='100%'>\n";
      echo "    <tr>\n";
      echo "     <td class='tbl2' rowspan='2' width='".($settings['pg_thumb_max_w']+8)."' align='center'><a class='gallery-album' href='{$PHP_SELF}?album_id={$d_albumlist['album_id']}'><img src='".FUSION_BASE."getpgimage.php?t=album&id={$d_albumlist['album_id']}&w={$settings['pg_thumb_max_w']}&h={$settings['pg_thumb_max_h']}' title='"."Click to open this Photo Album"."' alt='"."Loading Image..."."'></a></td>\n";
      echo "     <td class='tbl1' valign='top'><b><a href='{$PHP_SELF}?album_id={$d_albumlist['album_id']}' title='"."Click to open this Photo Album"."' >{$album_title}</a></b><span class='small'>{$str_album_pw}{$str_photo_updated}</span><br /><span class='small'>{$album_desc}</span></td>\n";
      echo "    </tr>\n";
      echo "    <tr>\n";
      echo "     <td class='tbl1' valign='bottom'><span class='small alt'>{$str_photo_count}</span></td>\n";
      echo "    </tr>\n";
      echo "   </table>\n";
      echo "  </td>\n";
      echo " </tr>\n";
      $album_cat_old=$d_albumlist['album_cat'];
    }
    echo "</table>\n";
  }else{
    echo "<table border='0' cellpadding='0' cellspacing='1' width='100%' class='tbl-border'>\n";
    echo " <tr>\n";
    echo "  <td class='gallery-cat' nowrap>"."Photo Galleries"."</td>\n";
    echo " </tr>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1'>"."No Photo Albums defined"."</td>\n";
    echo " </tr>\n";
    echo "</table>\n";
  }
  echo "<div style='margin:5px;' align='center'>\n";
  if($cnt_albums_total>$settings['pg_albums_per_page'] && $cnt_albumlist_page>0){
    $link="";
    if($cat_id>0) $link="{$PHP_SELF}?cat_id={$cat_id}&";
    echo makePageNavAll($page,$page_cnt,null,$link)."<br />\n";
  }
  if($settings['pg_allow_user_galleries']>0){
    $cnt_memberalbum=dbresult(dbquery("SELECT COUNT(*) FROM ".$fusion_prefix."users LEFT JOIN {$fusion_prefix}photos USING(user_id) WHERE album_id='0'"),0);
    if($cnt_memberalbum==0) $cnt_memberalbum='None';
    echo "<a href='membergallery.php'>View Member Albums ({$cnt_memberalbum})</a><br />\n";
  }
  echo "</div>\n";
  closetable();
}

include "side_right.php";
include "footer.php";
?>